## TOS Block Analysis 

This project refers to the paper: An In-Depth Comparative Analysis of Cloud Block Storage Workloads: Findings and Implications. 

### Preface

This repository contains the following folders:

* **src**: The C++ source code of our analysis
* **r**: The R scripts for further processing and plotting
* **etc**: Property files we use during analysis 

When we run the analysis, these directories can be created:

* **bin**: The executables of the analyze scripts
* **result**: The results generated by `analyze*.cc` files
* **processed**: The results further processed by `process*.cc` files
* **figure**: The figures generated by the R scripts

### Run the analysis 

* Download the AliCloud traces from https://github.com/alibaba/block-traces
* Download the TencentCloud traces from http://iotta.snia.org/traces/27917 
* Download the MSRC traces from http://iotta.snia.org/traces/388
* Modify `scripts/common.sh` to specify the paths of AliCloud, TencentCloud, and MSRC traces
  * And also the paths of storing the final traces files (separated by volumes)
* Run `prepare.sh` to:
  * split the AliCloud and TencentCloud traces into csv files, divided by the volume names
  * check whether all the trace files are ready
* Run `run.sh` to analyse the traces and get the results for in total 22 findings. 
  * The results will be put into the directory `result/` and `processed/`.
  * The number of findings mentioned in the paper will be printed by the R scripts.
  * If you want to get the results for individual findings, go to `scripts/` and run the corresponding scripts.

